package org.cebs.corep.xbrl.action;

import java.io.Serializable;
import org.apache.struts.action.ActionError;

/**
 * Diese Klasse ist dafuer zustaendig, die Fehlermeldung aus einer Properties-Datei auszulesen und
 * ggf. zusaetzliche Informationen in die Fehlermeldung einzuarbeiten.
 * <br />
 * 
 * @author:     Matthias Gries
 */
public class ExceptionTransformer implements Serializable
{

  /**
   * Diese Methode ist notwendig geworden, da Struts fuer ActionError keinen
   * Konstruktor zur Verfuegung stellt, der ein Array aus Platzhaltern als
   * Input-Parameter hat. Diese Funktionalitaet wird aber benoetigt, da nicht immer bekannt ist,
   * wieviele Platzhalter an den ActionError uebergeben werden. Die Anzahl der
   * Platzhalter ist jedoch nach wie vor auf vier begrenzt.
   * <br />
   * 
   * @param  key     String
   * @param  params  Object[]
   * @return         ActionError
   */
  public static ActionError getActionError(String key, Object[] params)
  {

    ActionError error = null;

    if (params == null)
    {
      error = new ActionError(key);
    }
    else if (params.length == 0)
    {
      error = new ActionError(key);
    }
    else if (params.length == 1)
    {
      error = new ActionError(key, params[0]);
    }
    else if (params.length == 2)
    {
      error = new ActionError(key, params[0], params[1]);
    }
    else if (params.length == 3)
    {
      error = new ActionError(key, params[0], params[1], params[2]);
    }
    else if (params.length >= 4)
    {
      error = new ActionError(key, params[0], params[1], params[2], params[3]);
    }

    return error;
  }
}
